method Abs(x : int) returns (r : int)
  //ensures 0 <= r;
  // Also need these
  //ensures 0 <= x ==> r == x;
  //ensures x < 0 ==> r == -x;
  
  // Or simply
  ensures r == abs(x);
{
  if(x < 0)
   {r := -x;}
  else 
   {r := x;}
}

// If we make this a function method we can remove 
// the method above and use this both for computations
// and in specifications, as Dafny "remembers" bodies of 
// functions unlike methods.
function method abs(x : int) : int
{
  if x < 0 then -x else x
}

method Test(){
  // Not allowed to put method call in assertion
  // assert 0 < Abs(3) 
  assert 0 < abs(3); // OK, as abs is a function.
  
  //var v1 := abs(3); // To do this, need to declare abs a function method!
  var v := Abs(3);
  assert 0 < v;
  
  // Can't prove this from just first pre-condition. This is why the second and third are needed.
  assert v == 3;
}
